#! /home/T4F/terrain/tk4.0/Dist-sun4/bin/wish4.0 -f

# server machine name
# the machine name has to match the redering platform's name exactly.
set server nova.npac.syr.edu

#Initialize url stuff
set urllistfile "loclist"
set listlen 0
set res 30
set cellr 0
set cellc 0

#Global map corners
#set north 4743877
#set south 4713877
#set east 582732
#set west 552732
set north 4722877
set south 4692877
set east 531732
set west 501732

# Initialize variables
set minzoom 0
set maxzoom 3
set zoom_value 0

set image_llx 0
set image_lly 0
set image_urx 0
set image_ury 0

set basephotoname ./test
set photoname ./test_0.1.1.ppm

#x_max and y_max correspond to the total number of cols and rows
set x_max 1000
set y_max 1000
set image_height 300
set image_width 300

#Initialize the four corners of the screen, assuming a zoom level of
#0 and that the top lefthand corner of the image is being shown
set upper_left_x 0 
set upper_left_y $y_max
set upper_right_x 300 
set upper_right_y $y_max
set lower_left_x 0 
set lower_left_y [expr $y_max - 300]
set lower_right_x 300 
set lower_right_y [expr $y_max - 300]

#initialize the variables that return the answer to the queryxy
#procedure 
set current_screen_x -1
set current_screen_y -1

#bind Viewer <Enter> {colorfocus %W}
#bind Photo <Enter> {colorfocus %W}
#bind Toplevel <Enter> {colorfocus %W}

if {[file exists [format "%s_%d.1.2.ppm" $basephotoname 0]]} {
    set image_height_index 1
    set image_width_index 1
} else {
    set image_height_index 0
    set image_width_index 0
}


wm title . "NEW YORK INTERACTIVE JOURNEY DEMO"
wm minsize . 1 1

frame .screen -colormap new
#frame .screen
pack .screen -side top -fill both

frame .screen.control

frame .screen.control.zoom
label .screen.control.zoom.label -text "Zoom"
scale .screen.control.zoom.vscale -orient vertical \
      -length 180 -from $maxzoom -to $minzoom \
      -tickinterval 1 -bg Bisque1 -command morezoom

#pack .screen.control.zoom.label .screen.control.zoom.vscale \
#     -in .screen.control.zoom -side top

#determine the height and width of the image in value (value must be
#the name of a ppm file), and set image_urx and image_ury accordingly
proc find_image_dims value {
    global image_urx
    global image_ury

    set nums ""
    set f [open $value r]
    gets $f nums
    gets $f nums
    scan $nums "%d %d" image_urx image_ury
}

#determine the height and width of the image that would be produced by
#merging the 4 ppm files file1 - file4; set image_urx and image_ury
#accordingly 
proc find_multi_image_dims {file1 file2 file3 file4} {
    global image_urx
    global image_ury

    set nums ""
    set tempheight 0
    set tempwidth 0
    set image_urx 0
    set image_ury 0
    foreach file [list $file1 $file2] {
	set f [open $file r]
	gets $f nums
	gets $f nums
	scan $nums "%d %d" tempwidth tempheight
	set image_urx [expr $image_urx + $tempwidth]
    }
    foreach file [list $file1 $file3] {
	set f [open $file r]
	gets $f nums
	gets $f nums
	scan $nums "%d %d" tempwidth tempheight
	set image_ury [expr $image_ury + $tempheight]
    }
}


proc readppm {id name} {

  global image_llx image_lly image_urx image_ury

puts "id1 = $id"
#  $id read $name -from $image_llx $image_lly \
#                 -to $image_llx $image_lly
  $id read $name

}

 
frame .screen.control.map

find_image_dims $photoname
puts "photoname = $photoname"
set image_dim [format "%f %f %f %f" $image_llx $image_lly $image_urx $image_ury]

set photo_height [expr $image_ury - $image_lly]
set photo_width [expr $image_urx - $image_llx]
puts "ht = $photo_height wdith = $photo_width"
#set photo_item [image create photo \
#                                     -format ppm -height $photo_height \
#                                     -width $photo_width -palette 6/6/5]
set photo_item [image create photo \
                                     -palette 6/6/5]
puts "id = $photo_item"

canvas .screen.control.map.canvas -width 300 -height 300 \
       -xscrollcommand ".screen.control.map.scrollx set" \
       -yscrollcommand ".screen.control.map.scrolly set" \
       -scrollregion $image_dim

readppm $photo_item $photoname
.screen.control.map.canvas create image 0 0 -image $photo_item

scrollbar .screen.control.map.scrollx -orient horiz \
    -command {scrollx_update} \
    -bg maroon

pack .screen.control.map.scrollx -side bottom -fill x

scrollbar .screen.control.map.scrolly -orient vert \
	-command {scrolly_update} \
	-bg maroon 
pack .screen.control.map.scrolly -side right -fill y

pack .screen.control.map.scrollx .screen.control.map.scrolly \
.screen.control.map.canvas -in .screen.control.map

pack .screen.control.map .screen.control.zoom -in .screen.control -side right

pack .screen.control -in .screen -side top -fill both

pack .screen -in . -side top

