#! /home/T4F/terrain/tk4.0/Dist-sun4/bin/wish4.0 -f

#Initialize url stuff
set urllistfile "loclist"
set listlen 0
set res 30
set cellr 0
set cellc 0
set loc_sensitive "red"
set loc_insensitive "yellow"
set text_sensitive "blue"
set text_insensitive "yellow"

#Global map corners
#set north 4792877
#set south 4692877
#set east 631732
#set west 531732
set north 4743877
set south 4713877
set east 612732
set west 582732

# Initialize variables
set minzoom 0
set maxzoom 3
set zoom_value 0
set scroll_dir 0

set basephotoname ./seg
set photoname ./seg_0.0.0.ppm

#x_max and y_max correspond to the total number of cols and rows
set max_cell_cols 4
set max_cell_rows 4
set x_max 1024
set y_max 1024

#these are the logical canvas and display window coordinates
set imgwin_height 256
set imgwin_width 256
set image_height 512
set image_width 512
set canvas_llx 0
set canvas_lly 0
set canvas_urx $image_width
set canvas_ury $image_height
set display_llx 0
set display_lly 0
set display_urx $imgwin_width
set display_ury $imgwin_height

#these are the coordinates of the window displayed on screen
set imgcell_height [expr 2 * [expr $image_height/$max_cell_rows]] 
set imgcell_width [expr 2 * [expr $image_width/$max_cell_cols]] 
set show_canvas_height [expr 4 * $imgcell_height]
set show_canvas_width [expr 4 * $imgcell_width]
set show_canvas_llx 0
set show_canvas_lly 0
set show_canvas_urx $show_canvas_width
set show_canvas_ury $show_canvas_height
set show_height [expr 2 * $imgcell_height]
set show_width [expr 2 * $imgcell_width]

#Initialize the four corners of the screen, assuming a zoom level of
#0 and that the top lefthand corner of the image is being shown
set upper_left_x 0 
set upper_left_y 0
set upper_right_x 0
set upper_right_y 0
set lower_left_x 0 
set lower_left_y 0
set lower_right_x 0
set lower_right_y 0

#Initial block to be displayed
set focus_i 0
set focus_j 0

set xscroll_units 8
set yscroll_units 8
set jump_units 4
set lookahdx_now 100
set lookahdy_now 100
set lookahd_flag 0
set reset_flag 0
set file_toggle 0

#initialize the variables that return the answer to the queryxy procedure 
set current_screen_x -1
set current_screen_y -1

wm title . "NEW YORK INTERACTIVE JOURNEY DEMO"
wm minsize . 1 1

frame .screen -visual "pseudocolor" -colormap new
pack .screen -side top -fill both

frame .screen.control

#get the url list
set fd [open $urllistfile r]
gets $fd nurl
for {set i 0} {$i < $nurl} {incr i 1} {
  gets $fd temp
  scan $temp "%d %d %s %s" northing($i) easting($i) loc_name($i) url($i)
  set loc_color($i) $loc_sensitive
  set textag_color($i) $text_sensitive
  puts "$i $northing($i) $easting($i)"
}
close $fd


proc readppm {name} {

    global photo_item
    global imgcell_height imgcell_width

    set photo_temp [image create photo -palette 6/6/5]
    for {set m 0} {$m < 4} {incr m 1} {
       for {set n 0} {$n < 4} {incr n 1} {
         set indx [expr $m*4 + $n]
         set photo_item($indx) [image create photo -height $imgcell_height \
                                -width $imgcell_width -palette 6/6/5]
         set x1 [expr $n * [expr $imgcell_width/2]]
         set y1 [expr $m * [expr $imgcell_height/2]]
         set x2 [expr $x1 + [expr $imgcell_width/2]]
         set y2 [expr $y1 + [expr $imgcell_height/2]]
         $photo_temp blank
         $photo_temp read $name -from $x1 $y1 $x2 $y2 -to 0 0
         $photo_item($indx) copy $photo_temp -zoom 2
       }
    }

}

 
#procedure that, given an x and y UTM coordinate, determines the
#screen coordinates of that point; updates the global variables
#current_screen_x and current_screen_y with the answer
#Any point between (0,0) and (300,300) is a valid screen coordinate,
#any point not between those 2 points is not on the screen 

proc Queryxy {x y} {
    global lower_left_x
    global lower_left_y
    global current_screen_x
    global current_screen_y
    global zoom_value

    set temp [expr pow(2,$zoom_value)]
    set current_screen_x [expr [expr abs($lower_left_x - $x)]/$temp]
    set current_screen_y [expr [expr abs($lower_left_y - $y)]/$temp]
}


proc Utm2Cell {n e} {
    global cellr cellc
    global west south
    global res

    set cellc [expr [expr $e - $west]/$res]
    set cellr [expr [expr $n - $south]/$res]
    
}


proc FindLocs {} {
    global loclist
    global listlen
    global south west
    global northing easting
    global res
    global upper_left_x upper_left_y 
    global imgwin_height imgwin_width
    global nurl
    global logfd

    set curnorth [expr $south + [expr $upper_left_y * $res]]
    set cursouth [expr $curnorth - [expr $imgwin_height * $res]]
    set curwest [expr $west + [expr $upper_left_x * $res]]
    set cureast [expr $curwest + [expr $imgwin_width * $res]]
    set listlen 0
    set loclist($listlen) 0
    puts "$curnorth $cursouth $curwest $cureast"
    for {set i 0} {$i < $nurl} {incr i 1} {
	  if {$northing($i) <= $curnorth && $northing($i) >= $cursouth && \
	  	  $easting($i) >= $curwest && $easting($i) <= $cureast} {
          set loclist($listlen) $i
	      set listlen [expr $listlen + 1]
	  }
    }
}


proc PopUpLocs {} {
    global loclist
    global listlen
    global loctag
    global locttag
    global loc_name
    global cellr cellc
    global northing easting
    global current_screen_x current_screen_y
    global loc_color
    global textag_color
    global texttag

    #create text and dot widgets for the url list
    for {set i 0} {$i < $listlen} {incr i 1} {
	set j $loclist($i)
	set texttag($i) [.screen.list.canvas create text 0.15c $i.75c -text \
		$loc_name($j) -fill $textag_color($j) -anchor sw]
	Utm2Cell $northing($j) $easting($j)
	Queryxy $cellc $cellr
	set x1($i) [expr $current_screen_x - 5]
	set y1($i) [expr $current_screen_y - 5]
	set x2($i) [expr $x1($i)+10]
	set y2($i) [expr $y1($i)+10]
	set loctag($i) [.screen.control.map.canvas create oval $x1($i) $y1($i) \
		$x2($i) $y2($i) -fill $loc_color($j)]
	set locttag($i) [.screen.control.map.canvas create text [expr $x1($i)-5] \
		[expr $y1($i)-5] -text $loc_name($j) -fill $loc_color($j) -anchor sw]
	
    }

    #and bind them
    for {set i 0} {$i < $listlen} {incr i 1} {
	.screen.list.canvas bind $texttag($i) <Button-1> "DisplayText $i"
	.screen.control.map.canvas bind $loctag($i) <Button-1> "SendUrl $i url"
	.screen.control.map.canvas bind $locttag($i) <Button-1> "SendUrl $i url"
	.screen.control.map.canvas bind $loctag($i) <Button-3> "DeleteTag $i"
	.screen.control.map.canvas bind $locttag($i) <Button-3> "DeleteTag $i"
    }
}


proc scrollx {val0 val1 args} {

   global scroll_dir 
   global display_llx display_lly
   global display_urx display_ury
   global canvas_llx canvas_lly
   global canvas_urx canvas_ury
   global imgwin_width
   global xscroll_units
   global jump_units
   global lookahdx_now
   global lookahd_flag
   global x_max

   set display_llx [expr $display_llx + [expr $val1 * $xscroll_units]]
   set display_urx [expr $display_urx + [expr $val1 * $xscroll_units]]
   if {$val1 == 1 || $val1 == [expr $jump_units * 1]} {
     set scroll_dir 4
     if {[expr $canvas_urx - $display_urx] <= $lookahdx_now} {
       if {$lookahd_flag != $scroll_dir} {
         if {$canvas_urx != $x_max} {
           LookAhead $scroll_dir 0
         }
       }
     }
     if {$display_urx > $canvas_urx} {
       set display_urx $canvas_urx
       set display_llx [expr $display_urx - $imgwin_width]
     }
     if {$display_urx == $x_max} {
       return
     }
     if {$display_urx == $canvas_urx} {
       if {$canvas_urx != $x_max} {
         UpdateCanvas $scroll_dir
       }
     }
   } elseif {$val1 == -1 || $val1 == [expr $jump_units * -1]} {
     set scroll_dir 2
     if {[expr $display_llx - $canvas_llx] <= $lookahdx_now} {
       if {$lookahd_flag != $scroll_dir} {
         if {$canvas_llx != 0} {
           LookAhead $scroll_dir 0
         }
       }
     }
     if {$display_llx < $canvas_llx} {
       set display_llx $canvas_llx
       set display_urx [expr $display_llx + $imgwin_width]
     }
     if {$display_llx == 0} {
       return
     }
     if {$display_llx == $canvas_llx} {
       if {$canvas_llx != 0} {
         UpdateCanvas $scroll_dir
       }
     }
   }
   .screen.control.map.canvas xview $val0 $val1 $args 
}



proc scrolly {val0 val1 args} {

   global scroll_dir 
   global display_llx display_lly
   global display_urx display_ury
   global canvas_llx canvas_lly
   global canvas_urx canvas_ury
   global imgwin_height
   global yscroll_units
   global jump_units
   global lookahdy_now
   global lookahd_flag
   global y_max

   set display_lly [expr $display_lly + [expr $val1 * $yscroll_units]]
   set display_ury [expr $display_ury + [expr $val1 * $yscroll_units]]
   if {$val1 == -1 || $val1 == [expr $jump_units * -1]} {
     set scroll_dir 1
     if {[expr $display_ury - $canvas_ury] <= $lookahdy_now} {
       if {$lookahd_flag != $scroll_dir} {
         if {$canvas_ury != 0} {
           LookAhead $scroll_dir 0
         }
       }
     }
     if {$display_ury < $canvas_ury} {
       set display_ury $canvas_ury
       set display_lly [expr $display_ury + $imgwin_height]
     }
     if {$display_ury == 0} {
       return
     }
     if {$display_ury == $canvas_ury} {
       if {$canvas_ury != 0} {
         UpdateCanvas $scroll_dir
       }
     }
   } elseif {$val1 == 1 || $val1 == [expr $jump_units * 1]} {
     set scroll_dir 3
     if {[expr $canvas_lly - $display_lly] <= $lookahdy_now} {
       if {$lookahd_flag != $scroll_dir} {
         if {$canvas_lly != $y_max} {
           LookAhead $scroll_dir 0
         }
       }
     }
     if {$display_lly > $canvas_lly} {
       set display_lly $canvas_lly
       set display_ury [expr $display_lly - $imgwin_height]
     }
     if {$display_lly == $y_max} {
       return
     }
     if {$display_lly == $canvas_lly} {
       if {$canvas_lly != $y_max} {
         UpdateCanvas $scroll_dir
       }
     }
   }
   .screen.control.map.canvas yview $val0 $val1 $args 
}



proc jump {val0 val1 args} {

   global scroll_dir 
   
   if {$scroll_dir == 1} {
     set val1 [expr -1 * $val1]
     scrolly $val0 $val1 $args
   } elseif {$scroll_dir == 2} {
     set val1 [expr -1 * $val1]
     scrollx $val0 $val1 $args
   } elseif {$scroll_dir == 3} {
     scrolly $val0 $val1 $args
   } elseif {$scroll_dir == 4} {
     scrollx $val0 $val1 $args
   }
}



proc ShowInitMap {i j} {

    global upper_left_x upper_left_y
    global upper_right_x upper_right_y
    global lower_left_x lower_left_y
    global lower_right_x lower_right_y
    global canvas_llx canvas_lly
    global canvas_urx canvas_ury
    global show_canvas_llx show_canvas_lly
    global show_canvas_urx show_canvas_ury
    global display_llx display_lly
    global display_urx display_ury
    global image_width image_height 
    global imgwin_width imgwin_height
    global zoom_value

    CInitDisplay $i $j
    set filename "seg_0."
    append filename "$j.$i"
    set photoname [format "%s.ppm" $filename]
    readppm $photoname
    set lower_left_x [expr $i * $image_width + [expr 0.5 * $image_width - \
                      $imgwin_width]]
    set lower_left_y [expr $j * $image_height + [expr 0.5 * $image_height - \
                      $imgwin_height]]
    set lower_right_x [expr $lower_left_x + $imgwin_width]
    set lower_right_y $lower_left_y
    set upper_left_x $lower_left_x
    set upper_left_y [expr $lower_left_y + $imgwin_height]
    set upper_right_x $lower_right_x
    set upper_right_y $upper_left_y

    set canvas_llx [expr $i * $image_width]
    set canvas_ury [expr $j * $image_height]
    set canvas_urx [expr $canvas_llx + $image_width]
    set canvas_lly [expr $canvas_ury + $image_height]
    set show_canvas_llx $canvas_llx
    set show_canvas_ury $canvas_ury
    set show_canvas_lly [expr 2 * $canvas_lly]
    set show_canvas_urx [expr 2 * $canvas_urx]
    set display_ury $canvas_ury
    set display_lly [expr $canvas_ury + $imgwin_height]
    set display_llx $canvas_llx
    set display_urx [expr $display_llx + $imgwin_width]

    set zoom_value 0

    FindLocs
    PopUpLocs
}



proc PositionWin {} {

    global image_width image_height 
    global canvas_llx canvas_lly
    global canvas_urx canvas_ury
    global display_llx display_lly
    global display_urx display_ury
    global xscroll_units yscroll_units

    set canvas_center_i [expr [expr $canvas_llx + $canvas_urx]/2]
    set canvas_center_j [expr [expr $canvas_lly + $canvas_ury]/2]
    set display_center_i [expr [expr $display_llx + $display_urx]/2]
    set display_center_j [expr [expr $display_lly + $display_ury]/2]
    set move_i [expr $canvas_center_i - $display_center_i]
    set move_j [expr $canvas_center_j - $display_center_j]
    set scroll_iunits [expr 2 * [expr $move_i/$xscroll_units]]
    set scroll_junits [expr 2 * [expr $move_j/$yscroll_units]]
    scrollx scroll $scroll_iunits units
    scrolly scroll $scroll_junits units
}




frame .screen.control.map
set canvas_center_i [expr 0.5 * $image_width]
set canvas_center_j [expr 0.5 * $image_height]
ShowInitMap $focus_i $focus_j
set segsize [format "%f %f %f %f" 0 0 $show_canvas_width $show_canvas_height]
canvas .screen.control.map.canvas -width $show_width \
        -height $show_height -scrollregion $segsize -confine 1 \
        -xscrollincrement $xscroll_units -yscrollincrement $yscroll_units
puts "setting up canvas"
for {set m 0} {$m < 4} {incr m 1} {
   for {set n 0} {$n < 4} {incr n 1} {
      set indx [expr $m*4 + $n]
      set anchor_i [expr $n * $imgcell_width]
      set anchor_j [expr $m * $imgcell_height]
      set cell_content($indx) $indx
      set tt($indx) [.screen.control.map.canvas create image $anchor_i \
                                        $anchor_j -image $photo_item($indx) \
                                        -tags photo($indx) -anchor nw]
   }
}
puts "done"
.screen.control.map.canvas addtag cells all
PositionWin

#create a scrolled canvas for the url list
frame .screen.list

set frame_llx 0
set frame_lly 0
set frame_urx 100
set frame_ury $imgwin_height
set frame_dim [format "%f %f %f %f" $frame_llx $frame_lly $frame_urx \
	       $frame_ury]
canvas .screen.list.canvas -width 100 -height $imgwin_height
scrollbar .screen.list.scrolly -orient vertical \
       -command {list_scrolly}
pack .screen.list.scrolly -in .screen.list -side right -fill y
pack .screen.list.canvas -in .screen.list -side left -fill both
pack .screen.list -in .screen -side left -fill both

#create a frame for the display and quit buttons
frame .screen.display
button .screen.display.quit -text "Quit"
button .screen.display.wipe -text "Wipe"
button .screen.display.redisplay -text "Redisplay"
bind .screen.display.quit <Button-1> Quit
bind .screen.display.wipe <Button-1> Wipe
bind .screen.display.redisplay <Button-1> Redisplay
pack .screen.display.quit -in .screen.display -side left -padx 10
pack .screen.display.wipe -in .screen.display -side left -padx 10
pack .screen.display.redisplay -in .screen.display -side left -padx 10
pack .screen.display -in .screen -side bottom -fill y

#create frames for the scroll and screen buttons
frame .screen.scrollzoom0
button .screen.scrollzoom0.scrolld -bitmap @down_arrow.xbm
bind .screen.scrollzoom0.scrolld <Button-1> [list scrolly \
                                scroll 1 units]
frame .screen.scrollzoom0.buf -width 80
pack .screen.scrollzoom0.buf -in .screen.scrollzoom0 -side left
pack .screen.scrollzoom0.scrolld -in .screen.scrollzoom0 -side left
pack .screen.scrollzoom0 -in .screen -side bottom -fill y

frame .screen.scrollzoom
button .screen.scrollzoom.scrolll -bitmap @left_arrow.xbm
button .screen.scrollzoom.scrollr -bitmap @right_arrow.xbm
button .screen.scrollzoom.jump -bitmap @square.xbm
button .screen.scrollzoom.zoomin -bitmap @plus.xbm
button .screen.scrollzoom.zoomout -bitmap @minus.xbm
bind .screen.scrollzoom.scrolll <Button-1> [list scrollx \
                                scroll -1 units]
bind .screen.scrollzoom.scrollr <Button-1> [list scrollx \
                                scroll 1 units]
bind .screen.scrollzoom.jump  <Button-1> [list jump \
                                scroll $jump_units units]
#bind .screen.scrollzoom.zoomin <Button-1> [list zoom 1]
#bind .screen.scrollzoom.zoomout <Button-1> [list zoom -1]
pack .screen.scrollzoom.zoomout -in .screen.scrollzoom -side left
pack .screen.scrollzoom.zoomin -in .screen.scrollzoom -side left
frame .screen.scrollzoom.buf -width 20
pack .screen.scrollzoom.buf -in .screen.scrollzoom -side left
pack .screen.scrollzoom.scrolll -in .screen.scrollzoom -side left
pack .screen.scrollzoom.jump -in .screen.scrollzoom -side left 
pack .screen.scrollzoom.scrollr -in .screen.scrollzoom -side left
pack .screen.scrollzoom -in .screen -side bottom -fill y

frame .screen.scrollzoom1
label .screen.scrollzoom1.label1 -text "Zoom"
button .screen.scrollzoom1.scrollu -bitmap @up_arrow.xbm
bind .screen.scrollzoom1.scrollu <Button-1> [list scrolly \
                                scroll -1 units]
frame .screen.scrollzoom1.buf -width 40
pack .screen.scrollzoom1.label1 .screen.scrollzoom1 -side left
pack .screen.scrollzoom1.buf -in .screen.scrollzoom1 -side left
pack .screen.scrollzoom1.scrollu -in .screen.scrollzoom1 -side left
pack .screen.scrollzoom1 -in .screen -side bottom -fill y

proc Wipe {} {

    global loctag
    global locttag
    global listlen
    
    for {set i 0} {$i < $listlen} {incr i 1} {
	.screen.control.map.canvas delete $loctag($i)
	set loctag($i) 0
	.screen.control.map.canvas delete $locttag($i)
	set locttag($i) 0
    }
}

proc Redisplay {} {

    global loclist
    global loctag
    global locttag
    global listlen
    global loc_name
    global northing easting
    global cellr cellc
    global current_screen_x current_screen_y
    global loc_color
    
    for {set i 0} {$i < $listlen} {incr i 1} {
	if {$loctag($i) == 0} {
	    set j $loclist($i)
	    Utm2Cell $northing($j) $easting($j)
	    Queryxy $cellc $cellr
	    set x1($i) [expr $current_screen_x - 5]
	    set y1($i) [expr $current_screen_y - 5]
	    set x2($i) [expr $x1($i)+10]
	    set y2($i) [expr $y1($i)+10]
	    set loctag($i) [.screen.control.map.canvas create oval $x1($i) $y1($i) \
		    $x2($i) $y2($i) -fill $loc_color($j)]
	    .screen.control.map.canvas bind $loctag($i) <Button-1> "SendUrl $i url"
	    .screen.control.map.canvas bind $loctag($i) <Button-3> "DeleteTag $i"
	    set locttag($i) [.screen.control.map.canvas create text [expr $x1($i)-5] \
		    [expr $y1($i)-5] -text $loc_name($i) -fill $loc_color($j) -anchor sw]
	    .screen.control.map.canvas bind $locttag($i) <Button-1> "SendUrl $i url"
	    .screen.control.map.canvas bind $locttag($i) <Button-3> "DeleteTag $i"
	}
    }
}

proc DisplayText {i} {
  
    global loclist
    global loctag 
    global locttag
    global loc_name
    global northing easting
    global cellr cellc
    global current_screen_x current_screen_y
    global loc_color
    global loc_sensitive

    if {$loctag($i) == 0} {
	set j $loclist($i)
	Utm2Cell $northing($j) $easting($j)
	Queryxy $cellc $cellr
	set x1($i) [expr $current_screen_x - 5]
	set y1($i) [expr $current_screen_y - 5]
	set x2($i) [expr $x1($i)+10]
	set y2($i) [expr $y1($i)+10]
	set loctag($i) [.screen.control.map.canvas create oval $x1($i) $y1($i) \
		$x2($i) $y2($i) -fill $loc_color($j)]
#    if {[string compare $loc_color($j) $loc_sensitive] == 0} {
	   .screen.control.map.canvas bind $loctag($i) <Button-1> "SendUrl $i url"
#    }
	.screen.control.map.canvas bind $loctag($i) <Button-3> "DeleteTag $i"
	set locttag($i) [.screen.control.map.canvas create text [expr $x1($i)-5] \
		[expr $y1($i)-5] -text $loc_name($i) -fill $loc_color($j) -anchor sw]
#    if {[string compare $loc_color($j) $loc_sensitive] == 0} {
	   .screen.control.map.canvas bind $locttag($i) <Button-1> "SendUrl $i url"
#    }
	.screen.control.map.canvas bind $locttag($i) <Button-3> "DeleteTag $i"
    }
}


proc ShowListAgain {i} {

    global textag_color
    global loclist
    global loc_name
    global texttag

	set j $loclist($i)
	set texttag($i) [.screen.list.canvas create text 0.15c $i.75c -text \
		$loc_name($j) -fill $textag_color($j) -anchor sw]
	.screen.list.canvas bind $texttag($i) <Button-1> "DisplayText $i"
    
}



proc SendUrl {i urln} {

    global loclist
    global loctag
    global locttag
    global loc_color
    global texttag
    global textag_color
    global loc_insensitive text_insensitive

    upvar $urln url
	set j $loclist($i)
    set loc_color($j) $loc_insensitive
    .screen.control.map.canvas delete $loctag($i)
    set loctag($i) 0
    .screen.control.map.canvas delete $locttag($i)
    set locttag($i) 0
    DisplayText "$i"
    set textag_color($j) $text_insensitive
    .screen.list.canvas delete $texttag($i)
    set texttag($i) 0
    ShowListAgain "$i"
    sendurl $url($i)
}



proc DeleteTag {i} {

    global loctag
    global locttag

    .screen.control.map.canvas delete $loctag($i)
    set loctag($i) 0
    .screen.control.map.canvas delete $locttag($i)
    set locttag($i) 0
}



proc Quit {} {

   quit
   exit
}



proc LookAhead {dir type} {

  global lookahd_flag
  global reset_flag
  global focus_i focus_j
  global max_cell_cols max_cell_rows
  global file_toggle
 
  set lookahd_flag $dir
  CUpdateLinks $dir $focus_i $focus_j
  CLookAhead $dir $type
  set reset_flag 1

}



proc UpdateCanvas {dir} {

  global photo
  global photo_item
  global image_width image_height 
  global show_canvas_width show_canvas_height 
  global canvas_llx canvas_lly
  global canvas_urx canvas_ury
  global show_canvas_llx show_canvas_lly
  global show_canvas_urx show_canvas_ury
  global imgcell_height imgcell_width
  global lookahd_flag
  global reset_flag
  global file_toggle
  global cell_content

#puts "getting lock"
  CGetFileLocks
#puts "gotcha"
  if {$dir == 1} {
    set show_canvas_ury [expr $show_canvas_ury - $imgcell_height]
    set show_canvas_lly [expr $show_canvas_ury + $show_canvas_height]
    set canvas_ury [expr $canvas_ury - [expr $imgcell_height/2]]
    set canvas_lly [expr $canvas_ury + $image_height]
    set indx(0) $cell_content(12)
    set indx(1) $cell_content(13)
    set indx(2) $cell_content(14)
    set indx(3) $cell_content(15)
    set cell_content(12) $cell_content(8)
    set cell_content(13) $cell_content(9)
    set cell_content(14) $cell_content(10)
    set cell_content(15) $cell_content(11)
    set cell_content(8) $cell_content(4)
    set cell_content(9) $cell_content(5)
    set cell_content(10) $cell_content(6)
    set cell_content(11) $cell_content(7)
    set cell_content(4) $cell_content(0)
    set cell_content(5) $cell_content(1)
    set cell_content(6) $cell_content(2)
    set cell_content(7) $cell_content(3)
    set cell_content(0) $indx(0)
    set cell_content(1) $indx(1)
    set cell_content(2) $indx(2)
    set cell_content(3) $indx(3)
    set move_y [expr -4 * $imgcell_height]
    .screen.control.map.canvas move photo($indx(0)) 0 $move_y
    .screen.control.map.canvas move photo($indx(1)) 0 $move_y
    .screen.control.map.canvas move photo($indx(2)) 0 $move_y
    .screen.control.map.canvas move photo($indx(3)) 0 $move_y
  } elseif {$dir == 2} {
    set show_canvas_llx [expr $show_canvas_llx - $imgcell_width]
    set show_canvas_urx [expr $show_canvas_llx + $show_canvas_width]
    set canvas_llx [expr $canvas_llx - [expr $imgcell_width/2]]
    set canvas_urx [expr $canvas_llx + $image_width]
    set indx(0) $cell_content(3)
    set indx(1) $cell_content(7)
    set indx(2) $cell_content(11)
    set indx(3) $cell_content(15)
    set cell_content(3) $cell_content(2)
    set cell_content(2) $cell_content(1)
    set cell_content(1) $cell_content(0)
    set cell_content(0) $indx(0)
    set cell_content(7) $cell_content(6)
    set cell_content(6) $cell_content(5)
    set cell_content(5) $cell_content(4)
    set cell_content(4) $indx(1)
    set cell_content(11) $cell_content(10)
    set cell_content(10) $cell_content(9)
    set cell_content(9) $cell_content(8)
    set cell_content(8) $indx(2)
    set cell_content(15) $cell_content(14)
    set cell_content(14) $cell_content(13)
    set cell_content(13) $cell_content(12)
    set cell_content(12) $indx(3)
    set move_x [expr -4 * $imgcell_width]
    .screen.control.map.canvas move photo($indx(0)) $move_x 0
    .screen.control.map.canvas move photo($indx(1)) $move_x 0
    .screen.control.map.canvas move photo($indx(2)) $move_x 0
    .screen.control.map.canvas move photo($indx(3)) $move_x 0
  } elseif {$dir == 3} {
    set show_canvas_lly [expr $show_canvas_lly + $imgcell_height]
    set show_canvas_ury [expr $show_canvas_lly - $show_canvas_height]
    set canvas_lly [expr $canvas_lly + [expr $imgcell_height/2]]
    set canvas_ury [expr $canvas_lly - $image_height]
    set indx(0) $cell_content(0)
    set indx(1) $cell_content(1)
    set indx(2) $cell_content(2)
    set indx(3) $cell_content(3)
    set cell_content(0) $cell_content(4)
    set cell_content(1) $cell_content(5)
    set cell_content(2) $cell_content(6)
    set cell_content(3) $cell_content(7)
    set cell_content(4) $cell_content(8)
    set cell_content(5) $cell_content(9)
    set cell_content(6) $cell_content(10)
    set cell_content(7) $cell_content(11)
    set cell_content(8) $cell_content(12)
    set cell_content(9) $cell_content(13)
    set cell_content(10) $cell_content(14)
    set cell_content(11) $cell_content(15)
    set cell_content(12) $indx(0)
    set cell_content(13) $indx(1)
    set cell_content(14) $indx(2)
    set cell_content(15) $indx(3)
    set move_y [expr 4 * $imgcell_height]
    .screen.control.map.canvas move photo($indx(0)) 0 $move_y
    .screen.control.map.canvas move photo($indx(1)) 0 $move_y
    .screen.control.map.canvas move photo($indx(2)) 0 $move_y
    .screen.control.map.canvas move photo($indx(3)) 0 $move_y
  } else {
    set show_canvas_urx [expr $show_canvas_urx + $imgcell_width]
    set show_canvas_llx [expr $show_canvas_urx - $show_canvas_width]
    set canvas_urx [expr $canvas_urx + [expr $imgcell_width/2]]
    set canvas_llx [expr $canvas_urx - $image_width]
    set indx(0) $cell_content(0)
    set indx(1) $cell_content(4)
    set indx(2) $cell_content(8)
    set indx(3) $cell_content(12)
    set cell_content(0) $cell_content(1)
    set cell_content(1) $cell_content(2)
    set cell_content(2) $cell_content(3)
    set cell_content(3) $indx(0)
    set cell_content(4) $cell_content(5)
    set cell_content(5) $cell_content(6)
    set cell_content(6) $cell_content(7)
    set cell_content(7) $indx(1)
    set cell_content(8) $cell_content(9)
    set cell_content(9) $cell_content(10)
    set cell_content(10) $cell_content(11)
    set cell_content(11) $indx(2)
    set cell_content(12) $cell_content(13)
    set cell_content(13) $cell_content(14)
    set cell_content(14) $cell_content(15)
    set cell_content(15) $indx(3)
    set move_x [expr 4 * $imgcell_width]
    .screen.control.map.canvas move photo($indx(0)) $move_x 0
    .screen.control.map.canvas move photo($indx(1)) $move_x 0
    .screen.control.map.canvas move photo($indx(2)) $move_x 0
    .screen.control.map.canvas move photo($indx(3)) $move_x 0
  }
  set segsize [format "%f %f %f %f" $show_canvas_llx $show_canvas_lly \
                                    $show_canvas_urx $show_canvas_ury]
  .screen.control.map.canvas configure -scrollregion $segsize

  $photo_item($indx(0)) blank
  $photo_item($indx(1)) blank
  $photo_item($indx(2)) blank
  $photo_item($indx(3)) blank

  if {$file_toggle == 0} {
    $photo_item($indx(0)) read "cell0_0.ppm"
    $photo_item($indx(1)) read "cell0_1.ppm"
    $photo_item($indx(2)) read "cell0_2.ppm"
    $photo_item($indx(3)) read "cell0_3.ppm"
  } elseif {$file_toggle == 1} {
    $photo_item($indx(0)) read "cell1_0.ppm"
    $photo_item($indx(1)) read "cell1_1.ppm"
    $photo_item($indx(2)) read "cell1_2.ppm"
    $photo_item($indx(3)) read "cell1_3.ppm"
  }

  set lookahd_flag 0
  set reset_flag 0
  
}



pack .screen.control.map.canvas -in .screen.control.map

pack .screen.control.map -in .screen.control -side right

pack .screen.control -in .screen -side top -fill both

pack .screen -in . -side top

