#include <signal.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <errno.h>
#include <string.h>
#include <stdlib.h>

typedef struct Point {
  int row;
  int column;
  char url[80];
} Point;

typedef struct Tag {
  int northing;
  int easting;
  char loc_name[80];
  char url[80];
} Tag;

/* External functions used in this file */
int  RenderClient(char *errmsg);
int  SemOpen(int);
int  SemWait(int );
int  SemSignal(int );

/* Funcitons defined in this file */
int  ParseWinInfo(char *filename);
void MyInterr(int signo);
void CatchSignals(void );
void GetTagList(FILE *fd, int n, Tag **tag_list);
int GetUrl(Point *p, int n, Tag **tag_list, char *url, FILE *logfile);
void OpenUrl(char *hostname, char *url, FILE *logfile);
void KillUI();
